## murahatebu : make_cache.rb

require 'base.rb'

if ARGV.empty?
  puts "Usage : #{__FILE__} <date>"
  exit
end

module MuraHatebu

  TODAY = Time.now.to_date
  YESTADAY = TODAY - 1
  UNTIL_DATE = Time.parse( ARGV[0] ).to_date

  villagers = {}
  Util.loadfile_as_standard_format( Util.filename_to_path( 'village_people' ) ) {|name|
    villagers[name] = Villager.new( name )
  }

  hash = {}
  UNTIL_DATE.step( YESTADAY ) {|date|
    hash[date] = DailyData.new( date )
  }

  villagers.each{|name, villager|
    begin
      villager.get_bookmark{|bookmark|
        next if bookmark.time.to_date == TODAY
        if hash.has_key?( bookmark.time.to_date )
          daily_data = hash[bookmark.time.to_date]
          unless daily_data.data.any?{|one| one.bookmark_id == bookmark.bookmark_id }
            daily_data.data << bookmark
          end
        end
        Villager::STOP_GET_BOOKMARK if bookmark.time.to_date < UNTIL_DATE
      }
    rescue => e
      Util.default_error_log( e, "villager = #{name} : #{__LINE__}" )
    end
  }
  hash.each{|date, daily_data|
    daily_data.save_cache
  }
end
