## murahatebu : nocomment.rb

require 'base.rb'


module MuraHatebu
  ## -- ŋ߂̍XVŕ\Gg͈͓̔
  NOCOMMENT_DISPLAY_RECENT_DAY = 3

  ## -- f[^̕ۑt@C
  NOCOMMENT_DATA_FILENAME = 'nocomment_data.dat'

  ## -- Rgꗗ\TCg̃t@C
  NOCOMMENT_SITE_FILENAME = 'nocomment_site'

  ## -- ŋ߂̍XVꗗ̃t@C
  NOCOMMENT_RECENT_FILENAME = 'nocomment_recent.html'

  ## -- SLꗗ̃t@C
  NOCOMMENT_ALL_FILENAME = 'nocomment_all.html'


  ## -- NoCommentEntryTemplate -------------------------------------------
  class NoCommentEntryTemplate < HtmlTemplate
    FILENAME = Util.filename_to_path( 'template/nocomment_entry_template.html' )
    PARAMS_STRUCT = Struct.new( :title, :linked_title, :version )

    VillagerTemplate = define_new_child( :villagers,
      [:villager, :permalink_url, :tags, :comment, :date]
    )
  end

  ## -- NoCommentAllTemplate -------------------------------------------
  class NoCommentAllTemplate < HtmlTemplate
    FILENAME = Util.filename_to_path( 'template/nocomment_all_template.html' )
    PARAMS_STRUCT = Struct.new( :version )

    OneRowTemplate = define_new_child( :list, [:entry_id, :title, :count, :date] )
  end

  ## -- NoCommentRecentTemplate ----------------------------------------
  class NoCommentRecentTemplate < HtmlTemplate
    FILENAME = Util.filename_to_path( 'template/nocomment_recent_template.html' )
    PARAMS_STRUCT = Struct.new( :days, :version )

    define_child( :list, NoCommentAllTemplate::OneRowTemplate )
  end

  ## -- NoCommentManager -------------------------------------------------
  class NoCommentManager
    ## -- C
    def start
      ## -- Rgꗗ\TCgXg
      @nocomment_site_list = MatchingList.new( Util.filename_to_path( NOCOMMENT_SITE_FILENAME ) )

      ## -- ȑÕf[^̎荞
      database = PStore.new( Util.filename_to_path( NOCOMMENT_DATA_FILENAME ) )
      database.transaction{
        @entry_hash = database.fetch( 'data', {} )
        @recent_url = database.fetch( 'recent', [] )
        @done_date  = database.fetch( 'done_date', {} )
      }

      return if @done_date.has_key?( YESTADAY )

      ## -- LbVǂݍ
      daily_data = DailyData.new( YESTADAY )
      unless daily_data.cache_exist?
        raise "cache file not exist : #{daily_data.cache_filepath}"
      end
      daily_data.load_cache

      @done_date[YESTADAY] = true

      ## -- ̍XVꂽGgꗗ
      @updated_url = {}
      @recent_url = @recent_url.last( NOCOMMENT_DISPLAY_RECENT_DAY )
      @recent_url.push( @updated_url )

      daily_data.data.select {|bookmark| @nocomment_site_list.match( bookmark.target_url )
      }.each {|bookmark|
        unless @entry_hash.has_key?( bookmark.target_url )
          tmp = Entry.new( bookmark.target_url )
          tmp.get_data
          tmp.bookmarks.clear
          @entry_hash[bookmark.target_url] = tmp
        end
        @entry_hash[bookmark.target_url].bookmarks << bookmark
        @updated_url[bookmark.target_url] = true
      }

      @updated_url.each_key {|target_url|
        @entry_hash[target_url].sort_bookmarks_by_time
      }

      ## -- f[^ۑ
      database.transaction {
        database['data'] = @entry_hash
        database['recent'] = @recent_url
        database['done_date'] = @done_date
      }

      ## -- XVꂽĽ html ̍XV
      self.make_updated_entry_html_file

      ## -- SLꗗ̍XV
      self.make_all_html_file

      ## -- ŋ߂̍XVꗗ̍XV
      self.make_recent_html_file
    end


    ## -- HTML o͌n -----
    ## -- XVꂽĽ html ̍XV
    def make_updated_entry_html_file
      entry_template = NoCommentEntryTemplate.new

      @updated_url.keys.each {|url|
        entry = @entry_hash[url]
        entry_template.reset

        entry_template.params.title = CGI.escapeHTML( entry.title )
        entry_template.params.linked_title = entry.make_html_linked_title
        entry.bookmarks.reverse_each {|bookmark|
          entry_template.params.villagers {|villager_template|
            villager_template.params.villager = bookmark.user.name
            villager_template.params.permalink_url = bookmark.permalink_url
            villager_template.params.tags = bookmark.tags.join( ' ' )
            villager_template.params.comment = CGI.escapeHTML( bookmark.comment.to_s )
            villager_template.params.date = bookmark.time.to_date.to_standard_string
          }
        }
        entry_template.params.version = VERSION
        entry_template.write_to_file( Util.filename_to_path( "nocomment/#{entry.entry_id}.html" ) )
      }
    end

    ## -- SLꗗ̍XV
    def make_all_html_file
      all_template = NoCommentAllTemplate.new

      @entry_hash.values.sort_by {|entry| entry.bookmarks.last.time
      }.reverse_each{|entry|
        all_template.params.list {|one_row_template|
          one_row_template.params.entry_id = entry.entry_id
          one_row_template.params.title = CGI.escapeHTML( entry.title )
          one_row_template.params.count = entry.bookmarks.size
          one_row_template.params.date = entry.bookmarks.last.time.to_date.to_standard_string
        }
      }
      all_template.params.version = VERSION
      all_template.write_to_file( Util.filename_to_path( NOCOMMENT_ALL_FILENAME ) )
    end

    ## -- ŋ߂̍XVꗗ̍XV
    def make_recent_html_file
      recent_template = NoCommentRecentTemplate.new

      @recent_url.collect {|updated| updated.keys
      }.flatten.uniq.collect{|url| @entry_hash[url]
      }.sort_by {|entry| entry.bookmarks.last.time
      }.reverse_each {|entry|
        recent_template.params.list {|one_row_template|
          one_row_template.params.entry_id = entry.entry_id
          one_row_template.params.title = CGI.escapeHTML( entry.title )
          one_row_template.params.count = entry.bookmarks.size
          one_row_template.params.date = entry.bookmarks.last.time.to_date.to_standard_string
        }
      }
      recent_template.params.days = NOCOMMENT_DISPLAY_RECENT_DAY
      recent_template.params.version = VERSION
      recent_template.write_to_file( Util.filename_to_path( NOCOMMENT_RECENT_FILENAME ) )
    end

  end
end
## -- main ---------------------------------------------------------------
MuraHatebu::TODAY = Date.parse( ARGV[0] ) rescue Date.today
MuraHatebu::YESTADAY = MuraHatebu::TODAY - 1
MuraHatebu::NoCommentManager.new.start
