#! /usr/local/bin/ruby

require 'pstore'
require 'date'


LAST_DATE_FILENAME = 'lastdate'

TODAY = Date.parse( ARGV[0] ) rescue Date.today

class Time
  def to_date
    Date.new( self.year, self.month, self.day )
  end
end


def self_dir
  File.dirname( File.expand_path( __FILE__ ) )
end

def filename_to_path( filename )
  self_dir + '/' + filename
end


class ProgressStarter
  DB_KEY = 'progress_checked_time'
  def initialize( db )
    @db = db
    @db.transaction {
      @checked_time = @db.fetch( DB_KEY, self.make_checked_time( TODAY ) )
    }
    if @checked_time.keys.first.to_date < Time.now.to_date
      @checked_time = self.make_checked_time( TODAY )
    end
    p @checked_time
  end

  def make_checked_time( date )
    h = {}
    h[Time.mktime( date.year, date.month, date.day, 7, 0 )] = false
    h[Time.mktime( date.year, date.month, date.day, 11, 30 )] = false
    h[Time.mktime( date.year, date.month, date.day, 16, 50 )] = false
    h[Time.mktime( date.year, date.month, date.day, 21, 0 )] = false
    h
  end
  
  def check
    flag = false
    @checked_time.keys.sort.each {|time|
      break if time > Time.now
      next if @checked_time[time]
      @checked_time[time] = true
      flag = true
    }
    @db.transaction { @db[DB_KEY] = @checked_time }
    flag
  end
end


def start
  ## -- ʣưɻߡƱϢ³ɻ
  db = PStore.new( filename_to_path( LAST_DATE_FILENAME ) )
  db.transaction{
    if db.root?( 'processing' )
      time = db['processing']
      if time.class == Time && Time.now - time < 60 * 30
        return
      else
        db.delete( 'processing' )
      end
    end
    db['processing'] = Time.now
  }

  progress_starter = ProgressStarter.new( db )
  if progress_starter.check
    system( "/usr/local/bin/ruby -Ke #{self_dir}/progress.rb" )
  end

  begin
    lastdate = nil
    db.transaction{ lastdate = db['lastdate'] }
    return if lastdate == TODAY

    system( "/usr/local/bin/ruby -Ke #{self_dir}/murahatebu.rb " + ARGV[0].to_s )
    system( "/usr/local/bin/ruby -Ke #{self_dir}/analyze_villagers.rb " + ARGV[0].to_s )
    system( "/usr/local/bin/ruby -Ke #{self_dir}/nocomment.rb " + ARGV[0].to_s )

    db.transaction{
      db['lastdate'] = TODAY
    }

  ensure
    db.transaction{ db.delete( 'processing' ) }
  end
end

start
