
require 'base.rb'

def command( str )
  puts "doing : #{str}"
  system str
end

today = Time.now.strftime( '%y%m%d' )

d = 'murahatebu'

command "mkdir #{d}"

[
"archives",
"cache",
"nocomment",
"rss",
"site_analyzed",
"villager_analyzed",
"favicon",
].each{|one| command "mkdir #{d}\\#{one}" }

[
"*.rb",
"ssi_update.sh",
"default.css",
"village_people",
"murahachibu",
"nocomment_site",
"about.html",
"rss.html",
"blacklist.html",
"url_black_list_*",
].each{|one| command "cp #{one} #{d}" }

[
"analyze",
"template",
"nocomment",
].each{|one|
  command "cp -r #{one} #{d}"
}

command "mkdir #{d}\\favicon\\new #{d}\\favicon\\temp"
command "cp favicon/*.rb #{d}/favicon"

command "mzp -r \"source/murahatebu-#{MuraHatebu::VERSION}-#{today}.zip\" #{d}"
command "rm -rf #{d}"



## -- \[XJ֘A
class SourceTemplate < MuraHatebu::HtmlTemplate
  FILENAME = MuraHatebu::Util.filename_to_path( 'template/source_template.html' )
  PARAMS_STRUCT = Struct.new( :version )

  ListTemplate = define_new_child( :list, [:version, :filename] )
end

source_template = SourceTemplate.new
source_template.params.version = MuraHatebu::VERSION

source_array = []
Dir.glob( "./source/*.zip" ) {|filename|
  m = /\.\/source\/([^\-]+\-([^\-]+)\-([^\.]*).*)$/.match( filename )
  if m
    filename = m[1]
    version = m[2]
    date = Date.parse( m[3] )
    source_array << [filename, version, date]
  end
}

source_array.sort_by{|f, v, d| d }
.each{|filename, version, date|
  source_template.params.list {|list_template|
    list_template.params.version = version
    list_template.params.filename = filename
  }
}

source_template.write_to_file( "./source/index.html" )
